package ru.dbotthepony.kstarbound.client.gl.shader

import org.lwjgl.opengl.GL20.GL_COMPILE_STATUS
import org.lwjgl.opengl.GL20.glCompileShader
import org.lwjgl.opengl.GL20.glCreateShader
import org.lwjgl.opengl.GL20.glDeleteShader
import org.lwjgl.opengl.GL20.glGetShaderInfoLog
import org.lwjgl.opengl.GL20.glGetShaderiv
import org.lwjgl.opengl.GL20.glShaderSource
import ru.dbotthepony.kstarbound.client.StarboundClient
import ru.dbotthepony.kstarbound.client.gl.checkForGLError
import java.io.File

class GLShader(body: String, type: Int) {
	constructor(body: File, type: Int) : this(body.also { require(it.exists()) { "Shader file does not exists: $body" } }.readText(), type)
	val client = StarboundClient.current()
	val pointer = glCreateShader(type)

	init {
		checkForGLError()
		client.registerCleanable(this, ::glDeleteShader, pointer)
	}

	init {
		if (body == "") {
			throw IllegalArgumentException("Shader source is empty")
		}

		glShaderSource(pointer, body)
		glCompileShader(pointer)

		val result = intArrayOf(0)
		glGetShaderiv(pointer, GL_COMPILE_STATUS, result)

		if (result[0] == 0) {
			throw ShaderCompilationException(glGetShaderInfoLog(pointer))
		}

		checkForGLError()
	}
}
