package ru.dbotthepony.kstarbound.client.render

import it.unimi.dsi.fastutil.longs.Long2ObjectFunction
import it.unimi.dsi.fastutil.longs.Long2ObjectOpenHashMap
import it.unimi.dsi.fastutil.objects.Reference2ObjectFunction
import it.unimi.dsi.fastutil.objects.Reference2ObjectOpenHashMap
import ru.dbotthepony.kstarbound.client.gl.vertex.VertexBuilder
import java.util.stream.Stream

class MultiMeshBuilder {
	data class Entry(val config: RenderConfig<*>, val builder: VertexBuilder, val layer: Long)

	private val meshes = Reference2ObjectOpenHashMap<RenderConfig<*>, Long2ObjectOpenHashMap<Entry>>()

	fun get(config: RenderConfig<*>, layer: Long): VertexBuilder {
		return meshes.computeIfAbsent(config, Reference2ObjectFunction {
			Long2ObjectOpenHashMap()
		}).computeIfAbsent(layer, Long2ObjectFunction { Entry(config, VertexBuilder(config.program.attributes, config.initialBuilderCapacity), layer) }).builder
	}

	fun clear() = meshes.clear()
	fun isEmpty() = meshes.isEmpty()
	fun isNotEmpty() = meshes.isNotEmpty()

	fun meshes(): Stream<Entry> {
		return meshes.values.stream().flatMap { it.values.stream() }
	}
}
