package ru.dbotthepony.kstarbound.client.render

import ru.dbotthepony.kstarbound.client.gl.shader.GLShaderProgram
import ru.dbotthepony.kvector.arrays.Matrix4f

abstract class RenderConfig<out T : GLShaderProgram>(val program: T) {
	val client get() = program.client
	open val initialBuilderCapacity: Int get() = 64

	open fun setup(transform: Matrix4f = client.matrixStack.last()) {
		program.use()
	}

	open fun uninstall() {}
}
