
#version 330

layout (location = 0) in vec2 pos;
layout (location = 1) in vec4 color;

uniform mat3 viewMatrix; // camera
uniform mat3 worldMatrix; // world position
uniform mat3 modelMatrix; // mesh/local transformations

out vec4 vertexColor;

void main() {
	gl_Position = vec4(viewMatrix * worldMatrix * modelMatrix * vec3(pos, 0.0), 1.0);

	vertexColor = color;
}
